<?php
$errorMessages = array(
    "-1" => array('status' => '-1', 'code' => 'AUTH_FAILED', 'message' => 'Неправильний логін та/або пароль',), 
    "-2" => array('status' => '-2', 'code' => 'XML_ERROR', 'message' => 'Неправильний формат XML',), 
    "-3" => array('status' => '-3', 'code' => 'NOT_ENOUGH_CREDITS', 'message' => 'Недостатньо кредитів на акаунті користувача',), 
    "-4" => array('status' => '-4', 'code' => 'NO_RECIPIENTS', 'message' => 'Немає вірних номерів отримувачів',), 
    "-7" => array('status' => '-7', 'code' => 'BAD_SENDER_NAME', 'message' => 'Помилка в імені відправника',),
);

if (isset($_POST['send_sms'])) {

    $login = !empty($_POST['user_login']) ? $_POST['user_login'] : false;
    $password = !empty($_POST['user_passwort']) ? $_POST['user_passwort'] : false;
    $sender = !empty($_POST['sender']) ? $_POST['sender'] : false;
    $message = !empty($_POST['text_message']) ? $_POST['text_message'] : false;
    $phones = !empty($_POST['phones']) ? $_POST['phones'] : false;
    if ($phones) {
        $phones = explode("\n", $phones);
    }
    $send_type = !empty($_POST['send_type']) ? $_POST['send_type'] : 'now';
    $send_date = !empty($_POST['send_date']) ? $_POST['send_date'] : false;

    $numbersXml = '';
    foreach ($phones as $number) {
        if (!empty($number)) {
            $numbersXml .= '<number>' . $number . '</number>';
        }
    }

    if ($login && $password && $sender && $message && $phones) {
        $src = '<?xml version="1.0" encoding="UTF-8"?>';
        $src = $src . "<SMS> 
            <operations>  
                <operation>SEND</operation> 
            </operations> 
            <authentification>    
                <username>$login</username>   
                <password>$password</password>   
            </authentification>   
            <message> 
                <sender>$sender</sender>    
                <text>$message</text>   
            </message>    
            <numbers>
                $numbersXml
            </numbers>    
        </SMS>";

        // echo '<pre>' . print_r(htmlspecialchars($src, ENT_QUOTES, 'UTF-8'), 1) . '</pre>';

        $curl = curl_init();
        $curlOptions = array(
            CURLOPT_URL => 'http://api.atompark.com/members/sms/xml.php',
            CURLOPT_FOLLOWLOCATION => false,
            CURLOPT_POST => true,
            CURLOPT_HEADER => false,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_CONNECTTIMEOUT => 15,
            CURLOPT_TIMEOUT => 100,
            CURLOPT_POSTFIELDS => array('XML' => $src),
        );
        curl_setopt_array($curl, $curlOptions);
        if (false === ($xmlString = curl_exec($curl))) {
            throw new Exception('Http request failed');
        }

        curl_close($curl);

        $xml = simplexml_load_string($xmlString);
        $json = json_encode($xml);
        $result = json_decode($json, 1);

        // var_dump($result);
    }
}
?>
<!DOCTYPE HTML>
<html lang="en-US">
    <head>
        <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.3.1/jquery.min.js"></script>
        <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/js/bootstrap.min.js"></script>
        <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css">
        <meta charset="UTF-8">
        <title>Обработка HTML формы с помощью PHP</title>
        <script>
            $(function () {
                var send_type = $('#send_send_type');
                $('[name="send_type"]').change(function () {
                    var type = $(this).val();
                    switch (type) {
                        case 'now':
                            $('#send_type').hide();
                            break;
                        case 'date':
                            $('#send_type').show();
                            break;
                    }
                });
            });
        </script>
    </head>
    <body>

        <?php if (!empty($result)) { ?>
            <?php if ($result['status'] == 1) { ?>
                <div class="alert alert-success">
                    <strong>Success!</strong> Send sms success.
                </div>
            <?php } else { ?>
                <div class="alert alert-danger">
                    <strong>Error!</strong> <?php echo (!empty($errorMessages[$result['status']]) ? $errorMessages[$result['status']]['message'] : "Unknown error") ?>.
                </div>
            <?php } ?>
        <?php } ?>

        <form method="post" action="" enctype="application/x-www-form-urlencoded">
            <div class="form-group">
                <label for="user_login">User login</label>
                <input type="email" class="form-control" name="user_login" value="<?php echo (!empty($login) ? $login : '') ?>" id="user_login" placeholder="Enter email">
            </div>
            <div class="form-group">
                <label for="user_passwort">Password</label>
                <input type="password" class="form-control" name="user_passwort" value="<?php echo (!empty($password) ? $password : '') ?>" id="user_passwort" placeholder="Password">
            </div>
            <div class="form-group">
                <label for="sender">Sender</label>
                <input type="text" class="form-control" name="sender" value="<?php echo (!empty($sender) ? $sender : '') ?>" id="sender" placeholder="Sender">
            </div>
            <div class="form-group">
                <label for="text_message">Text message</label>
                <textarea class="form-control" name="text_message" id="text_message" rows="3"><?php echo (!empty($message) ? $message : '') ?></textarea>
            </div>
            <div class="form-group">
                <label for="phones">Phones</label>
                <textarea aria-describedby="emailHelp" class="form-control" name="phones" id="phones" rows="3"><?php echo (!empty($phones) ? implode("\n", $phones) : '') ?></textarea>
                <small id="emailHelp" class="form-text text-muted">each phone with a new line</small>
            </div>
            <fieldset class="form-group">
                <legend>Send type</legend>
                <div class="form-check">
                    <label class="form-check-label">
                        <input type="radio" class="form-check-input" name="send_type" id="send_type_now" value="now" checked>
                        Immediately
                    </label>
                </div>
                <div class="form-check">
                    <label class="form-check-label">
                        <input type="radio" class="form-check-input" name="send_type" id="send_type_date" value="date">
                        At date 
                    </label>
                </div>
            </fieldset>
            <div id="send_type" class="form-check" style="display: none">
                <label class="form-check-label">
                    <input name="send_date" id="send_date" type="datetime-local" class="form-check-input">
                    Datetime send
                </label>
            </div>
            <button id="send_sms" name="send_sms" type="submit" class="btn btn-primary">Send</button>
        </form>
    </body>
</html>
